﻿using System;
using EFLib;
using Model;

namespace DataManagers
{
	public static class LargeImageChanger
	{
        public static LargeImage ToPoco(this LargeImageEntity largeImage)
        {
            return new LargeImage(largeImage.Id, largeImage.Base64);
        }

        public static LargeImageEntity ToEntity(this LargeImage largeImage) => new LargeImageEntity
        {
            Id = largeImage.Id,
            Base64 = largeImage.Base64
        };


        public static IEnumerable<LargeImage> ToPocos(this IEnumerable<LargeImageEntity> largeImages)
        {
            List<LargeImage> images = new List<LargeImage>();
            foreach (LargeImageEntity l in largeImages)
            {
                images.Add(l.ToPoco());
            }
            return images;
        }

        public static IEnumerable<LargeImageEntity> toEntities(this IEnumerable<LargeImage> largeImages)
        {
            List<LargeImageEntity> images = new List<LargeImageEntity>();
            foreach (LargeImage l in largeImages)
            {
                images.Add(l.ToEntity());
            }
            return images;
        }
    }
}

